<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: genHostGroups.php 7139 2008-11-24 17:19:45Z jmathis $
 * 
 */ 
	if (!isset($oreon))
		exit();
	
	if (!is_dir($nagiosCFGPath.$tab['id']."/")) {
		mkdir($nagiosCFGPath.$tab['id']."/");
	}
	
	/*
	 * Create table to liste generated hostGroups
	 */
	 
	$generatedHG = array();
	$handle = create_file($nagiosCFGPath.$tab['id']."/hostgroups.cfg", $oreon->user->get_name());
	$DBRESULT =& $pearDB->query("SELECT * FROM hostgroup WHERE hg_activate = '1' ORDER BY `hg_name`");
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
	$hostGroup = array();
	$i = 1;
	$str = NULL;
	while ($hostGroup =& $DBRESULT->fetchRow())	{
		$BP = false;
		$strDef = NULL;
		$HGLinkedToHost = 0;
		array_key_exists($hostGroup["hg_id"], $gbArr[3]) ? $BP = true : NULL;
		
		/*
		 * Generate a new Hostgroup
		 */
		
		$ret["comment"] ? ($strDef .= "# '" . $hostGroup["hg_name"] . "' hostgroup definition " . $i . "\n") : NULL;
		if ($ret["comment"] && $hostGroup["hg_comment"])	{
			$comment = array();
			$comment = explode("\n", $hostGroup["hg_comment"]);
			foreach ($comment as $cmt)
				$strDef .= "# ".$cmt."\n";
		}
		$strDef .= "define hostgroup{\n";
		if ($hostGroup["hg_name"])	$strDef .= print_line("hostgroup_name", $hostGroup["hg_name"]);
		if ($hostGroup["hg_alias"]) $strDef .= print_line("alias", $hostGroup["hg_alias"]);
		
		/*
		 * Host Members
		 */
		
		$host = array();
		$strTemp = NULL;
		$DBRESULT2 =& $pearDB->query("SELECT host.host_id, host.host_name FROM hostgroup_relation hgr, host WHERE hgr.hostgroup_hg_id = '".$hostGroup["hg_id"]."' AND hgr.host_host_id = host.host_id ORDER BY `host_name`");
		if (PEAR::isError($DBRESULT2))
			print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
		while($host =& $DBRESULT2->fetchRow())	{
			$BP = false;
			array_key_exists($host["host_id"], $gbArr[2]) ? $BP = true : NULL;
			
			if ($BP && isHostOnThisInstance($host["host_id"], $tab['id'])){
				$HGLinkedToHost++;
				$strTemp != NULL ? $strTemp .= ", ".$host["host_name"] : $strTemp = $host["host_name"];
			}
		}
		$DBRESULT2->free();
		unset($host);
		if ($strTemp) $strDef .= print_line("members", $strTemp);
		unset($strTemp);
	
		/*
		 * Only for Nagios V1 : Contactgroups
		 */ 
	
		if ($oreon->user->get_version() == 1)	{
			$contactGroup = array();
			$strTemp = NULL;
			$DBRESULT2 =& $pearDB->query("SELECT cg.cg_name, cg.cg_id FROM contactgroup_hostgroup_relation cghgr, contactgroup cg WHERE cghgr.hostgroup_hg_id = '".$hostGroup["hg_id"]."' AND cghgr.contactgroup_cg_id = cg.cg_id ORDER BY `cg_name`");
			if (PEAR::isError($DBRESULT2))
				print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
			while($contactGroup =& $DBRESULT2->fetchRow())	{
				$BP = false;
				array_key_exists($contactGroup["cg_id"], $gbArr[1]) ? $BP = true : NULL;
				
				if ($BP)
					$strTemp != NULL ? $strTemp .= ", ".$contactGroup["cg_name"] : $strTemp = $contactGroup["cg_name"];
			}
			$DBRESULT2->free();
			unset($contactGroup);
			if ($strTemp) {
				$strDef .= print_line("contact_groups", $strTemp);
				
			}
			unset($strTemp);
		}
		
		/*
		 * Generate only if this hostgroup had a host generate on this nagios instance
		 */
		 
		if ($HGLinkedToHost){
			$generatedHG[$hostGroup["hg_id"]] = $hostGroup["hg_name"];
			$str .= $strDef;
			$str .= "}\n\n";
		}
		$strDef = "";
		$HGLinkedToHost = 0;
		unset($strDef);
		$i++;
		unset($hostGroup);
	}
	write_in_file($handle, html_entity_decode($str, ENT_QUOTES), $nagiosCFGPath.$tab['id']."/hostgroups.cfg");
	fclose($handle);
	$DBRESULT->free();
	unset($str);
	unset($i);
	?>