<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: genHosts.php 7249 2008-12-15 12:49:28Z jmathis $
 * 
 */
	if (!isset($oreon))
		exit();

	if (!is_dir($nagiosCFGPath.$tab['id']."/")) {
		mkdir($nagiosCFGPath.$tab['id']."/");
	}
	
	$handle = create_file($nagiosCFGPath.$tab['id']."/hosts.cfg", $oreon->user->get_name());
	$DBRESULT =& $pearDB->query("SELECT * FROM host WHERE host_activate = '1' ORDER BY `host_register`, `host_name`");
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
	$host = array();
	$i = 1;
	$str = NULL;
	while($host = $DBRESULT->fetchRow())	{
		if (isHostOnThisInstance($host["host_id"], $tab['id']) || $host["host_register"] == 0) {			
			$BP = false;			
			array_key_exists($host["host_id"], $gbArr[2]) ? $BP = true : NULL;			
			if (!$host["host_register"])
				$BP = true;				
			if ($BP)	{								
				$ret["comment"] ? ($str .= "# '" . $host["host_name"]."' host definition ".$i."\n") : NULL;
				if ($ret["comment"] && $host["host_comment"])	{
					$comment = array();
					$comment = explode("\n", $host["host_comment"]);
					foreach ($comment as $cmt)
						$str .= "# ".$cmt."\n";
				}
				$str .= "define host{\n";
				if (!$host["host_register"] && $host["host_name"])	
					$str .= print_line("name", $host["host_name"]);
				else
					if ($host["host_name"]) $str .= print_line("host_name", $host["host_name"]);									
				/*
				 * Get Template Model Relation
				 */
				
				/*
				 *  For Nagios 3 ::: Multi Templates
				 */
				if ($oreon->user->get_version() >= 3) {
					$rq = "SELECT host_tpl_id FROM `host_template_relation` WHERE host_host_id=" . $host["host_id"] . " ORDER BY `order`";
					$DBRESULT2 =& $pearDB->query($rq);
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
					$tpl_str = "";
					$first_on_list = 1;
					while ($tpl_id = $DBRESULT2->fetchRow()) {
						$rq = "SELECT host_name FROM `host` WHERE host_id=" . $tpl_id["host_tpl_id"];
						$DBRESULT3 =& $pearDB->query($rq);
						if (PEAR::isError($DBRESULT3))
							print "DB Error : ".$DBRESULT3->getDebugInfo()."<br />";
						while ($tpl_name = $DBRESULT3->fetchRow()) { 
							if ($first_on_list) {
								$first_on_list = 0;
								$tpl_str .= $tpl_name["host_name"];
							}
							else
								$tpl_str .= "," . $tpl_name["host_name"];							
						}	
					}
					if ($DBRESULT2->numRows())
						$str .= print_line("use", $tpl_str);
					$DBRESULT2->free();
				} else if ($host["host_template_model_htm_id"]) {			
					/*
					 *  For Nagios 1 & 2
					 */
					$hostTemplate = array();
					$DBRESULT2 =& $pearDB->query("SELECT host.host_name FROM host WHERE host.host_id = '".$host["host_template_model_htm_id"]."'");
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
					while($hostTemplate = $DBRESULT2->fetchRow())
						$str .= print_line("use", $hostTemplate["host_name"]);
					$DBRESULT2->free();
					unset($hostTemplate);		
				}
				
				if ($host["host_alias"]) 			$str .= print_line("alias", $host["host_alias"]);
				if ($host["host_address"]) 			$str .= print_line("address", $host["host_address"]);
				
				if ($oreon->user->get_version() > 2)	{
					if ($host["host_snmp_community"]) 	$str .= print_line("_SNMPCOMMUNITY", $host["host_snmp_community"]);
					if ($host["host_snmp_version"])		$str .= print_line("_SNMPVERSION", $host["host_snmp_version"]);
				}
				
				/* 
				 * Get Parents List for this host
				 */

				$hostParent = array();
				$strTemp = NULL;
				$DBRESULT2 =& $pearDB->query("SELECT host.host_id, host.host_name FROM host_hostparent_relation hhr, host WHERE hhr.host_host_id = '".$host["host_id"]."' AND hhr.host_parent_hp_id = host.host_id ORDER BY `host_name`");
				if (PEAR::isError($DBRESULT2))
					print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
				while($hostParent = $DBRESULT2->fetchRow())	{
					$DBRESULT3 =& $pearDB->query("SELECT * FROM ns_host_relation WHERE host_host_id = '".$hostParent["host_id"]."' AND nagios_server_id = '".$tab['id']."'");
					if (PEAR::isError($DBRESULT3))
						print "DB Error : ".$DBRESULT3->getDebugInfo()."<br />";
					if (verifyIfMustBeGenerated($host["host_id"], $gbArr[2], $ret) && $DBRESULT3->numRows())
						$strTemp != NULL ? $strTemp .= ", ".$hostParent["host_name"] : $strTemp = $hostParent["host_name"];
				}
				$DBRESULT2->free();
				if ($strTemp) $str .= print_line("parents", $strTemp);
				unset($hostParent);
				unset($strTemp);

				// Nagios V2 : Hostgroups relation
				if ($oreon->user->get_version() >= 2)	{
					$hostGroup = array();
					$strTemp = NULL;
					$DBRESULT2 =& $pearDB->query("SELECT hg.hg_id, hg.hg_name FROM hostgroup_relation hgr, hostgroup hg WHERE hgr.host_host_id = '".$host["host_id"]."' AND hgr.hostgroup_hg_id = hg.hg_id ORDER BY `hg_name`");
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
					while($hostGroup = $DBRESULT2->fetchRow())	{
						$BP = false;
						array_key_exists($hostGroup["hg_id"], $gbArr[3]) ? $BP = true : NULL;
						
						if ($BP)
							$strTemp != NULL ? $strTemp .= ", ".$hostGroup["hg_name"] : $strTemp = $hostGroup["hg_name"];
					}
					$DBRESULT2->free();
					unset($hostGroup);
					if ($strTemp) $str .= print_line("hostgroups", $strTemp);
					unset($strTemp);
				}
				
				/*
				 * Check Command
				 */
				 
				$command = array();
				$DBRESULT2 =& $pearDB->query("SELECT cmd.command_name FROM command cmd WHERE cmd.command_id = '".$host["command_command_id"]."' LIMIT 1");
				if (PEAR::isError($DBRESULT2))
					print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
				
				$host["command_command_id_arg1"] = removeSpecialChar($host["command_command_id_arg1"]);
				
				while ($command = $DBRESULT2->fetchRow())
					$str .= print_line("check_command", $command["command_name"].$host["command_command_id_arg1"]);
				$DBRESULT2->free();
				unset($command);
				
				if ($host["host_max_check_attempts"] != NULL) 	
					$str .= print_line("max_check_attempts", $host["host_max_check_attempts"]);
				if ($host["host_check_interval"] != NULL) 
					$str .= print_line("check_interval", $host["host_check_interval"]);
				if ($oreon->user->get_version() == 1)
					if ($host["host_checks_enabled"] != 2) 
						$str .= print_line("checks_enabled", $host["host_checks_enabled"] == 1 ? "1" : "0");
				if ($oreon->user->get_version() >= 2)	{
					if ($host["host_active_checks_enabled"] != 2) 
						$str .= print_line("active_checks_enabled", $host["host_active_checks_enabled"] == 1 ? "1": "0");
					if ($host["host_passive_checks_enabled"] != 2) 
						$str .= print_line("passive_checks_enabled", $host["host_passive_checks_enabled"] == 1 ? "1": "0");
					//Check Period
					$timePeriod = array();
					$DBRESULT2 =& $pearDB->query("SELECT tp.tp_name FROM timeperiod tp WHERE tp.tp_id = '".$host["timeperiod_tp_id"]."' LIMIT 1");
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
					while($timePeriod = $DBRESULT2->fetchRow())
						$str .= print_line("check_period", $timePeriod["tp_name"]);
					$DBRESULT2->free();
					unset($timePeriod);

					if ($host["host_obsess_over_host"] != 2) 
						$str .= print_line("obsess_over_host", $host["host_obsess_over_host"] == 1 ? "1": "0");
					if ($host["host_check_freshness"] != 2) 
						$str .= print_line("check_freshness", $host["host_check_freshness"] == 1 ? "1": "0");
					if ($host["host_freshness_threshold"]) 
						$str .= print_line("freshness_threshold", $host["host_freshness_threshold"]);
				}
				//Event_handler
				$command = array();
				$DBRESULT2 =& $pearDB->query("SELECT cmd.command_name FROM command cmd WHERE cmd.command_id = '".$host["command_command_id2"]."' LIMIT 1");
				if (PEAR::isError($DBRESULT2))
					print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
				
				$host["command_command_id_arg2"] = removeSpecialChar($host["command_command_id_arg2"]);
					
				while ($command = $DBRESULT2->fetchRow())
					$str .= print_line("event_handler", $command["command_name"].$host["command_command_id_arg2"]);
				$DBRESULT2->free();
				unset($command);
				//
				if ($host["host_event_handler_enabled"] != 2) 
					$str .= print_line("event_handler_enabled", $host["host_event_handler_enabled"] == 1 ? "1": "0");
				if ($host["host_low_flap_threshold"]) 
					$str .= print_line("low_flap_threshold", $host["host_low_flap_threshold"]);
				if ($host["host_high_flap_threshold"]) 
					$str .= print_line("high_flap_threshold", $host["host_high_flap_threshold"]);
				if ($host["host_flap_detection_enabled"] != 2) 
					$str .= print_line("flap_detection_enabled", $host["host_flap_detection_enabled"] == 1 ? "1": "0");
				if ($host["host_process_perf_data"] != 2) 
					$str .= print_line("process_perf_data", $host["host_process_perf_data"] == 1 ? "1": "0");
				if ($host["host_retain_status_information"] != 2) 
					$str .= print_line("retain_status_information", $host["host_retain_status_information"] == 1 ? "1": "0");
				if ($host["host_retain_nonstatus_information"] != 2) 
					$str .= print_line("retain_nonstatus_information", $host["host_retain_nonstatus_information"] == 1 ? "1": "0");
				
				/*
				 * Nagios V2 : contactGroups relation
				 */
				if ($oreon->user->get_version() >= 2)	{
					$contactGroup = array();
					$strTemp = NULL;
					$DBRESULT2 =& $pearDB->query("SELECT cg.cg_id, cg.cg_name FROM contactgroup_host_relation chr, contactgroup cg WHERE chr.host_host_id = '".$host["host_id"]."' AND chr.contactgroup_cg_id = cg.cg_id ORDER BY `cg_name`");
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
					while ($contactGroup =& $DBRESULT2->fetchRow())	{				
						if (isset($gbArr[1][$contactGroup["cg_id"]]))
							$strTemp != NULL ? $strTemp .= ", ".$contactGroup["cg_name"] : $strTemp = $contactGroup["cg_name"];
					}
					$DBRESULT2->free();
					unset($contactGroup);
					if ($strTemp) 
						$str .= print_line("contact_groups", $strTemp);
					unset($strTemp);
				}
				
				/*
				 * Nagios V3 : contacts relation
				 */
				if ($oreon->user->get_version() >= 3)	{
					$contact = array();
					$strTemp = NULL;
					$DBRESULT2 =& $pearDB->query("SELECT c.contact_id, c.contact_name FROM contact_host_relation chr, contact c WHERE chr.host_host_id = '".$host["host_id"]."' AND chr.contact_id = c.contact_id ORDER BY `contact_name`");
					if (PEAR::isError($DBRESULT2))
						print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";					
					while ($contact =& $DBRESULT2->fetchRow())	{				
						if (isset($gbArr[0][$contact["contact_id"]]))
							$strTemp != NULL ? $strTemp .= ", ".$contact["contact_name"] : $strTemp = $contact["contact_name"];
					}
					$DBRESULT2->free();
					unset($contact);
					if ($strTemp) 
						$str .= print_line("contacts", $strTemp);
					unset($strTemp);
				}
				
				if ($host["host_notification_interval"] != NULL) 
					$str .= print_line("notification_interval", $host["host_notification_interval"]);
				
				/*
				 * Timeperiod name
				 */
				$timePeriod = array();
				$DBRESULT2 =& $pearDB->query("SELECT tp.tp_name FROM timeperiod tp WHERE tp.tp_id = '".$host["timeperiod_tp_id2"]."' LIMIT 1");
				if (PEAR::isError($DBRESULT2))
					print "DB Error : ".$DBRESULT2->getDebugInfo()."<br />";
				while ($timePeriod =& $DBRESULT2->fetchRow())
					$str .= print_line("notification_period", $timePeriod["tp_name"]);
				$DBRESULT2->free();
				unset($timePeriod);
				
				if ($host["host_notification_options"]) 
					$str .= print_line("notification_options", $host["host_notification_options"]);
				if ($host["host_notifications_enabled"] != 2) 
					$str .= print_line("notifications_enabled", $host["host_notifications_enabled"] == 1 ? "1": "0");
				if ($host["host_stalking_options"]) 
					$str .= print_line("stalking_options", $host["host_stalking_options"]);
				if (!$host["host_register"]) 
					$str .= print_line("register", "0");
				
				/*
				 * On-demand macros
				 */
				if ($oreon->user->get_version() >= 3) {
					$rq = "SELECT `host_macro_name`, `host_macro_value` FROM `on_demand_macro_host` WHERE `host_host_id` = '" . $host['host_id']."'";
					$DBRESULT3 =& $pearDB->query($rq);
					if (PEAR::isError($DBRESULT3))
						print "DB Error : ".$DBRESULT3->getDebugInfo()."<br />";
					while ($od_macro =& $DBRESULT3->fetchRow()) {
						$mac_name = str_replace("\$_HOST", "_", $od_macro['host_macro_name']);
						$mac_name = str_replace("\$", "", $mac_name);
						$mac_value = $od_macro['host_macro_value'];
						$str .= print_line($mac_name, $mac_value);
					}
				}
				$str .= "}\n\n";
				$i++;
			}
		}
				
		unset($host);
	}	
	write_in_file($handle, html_entity_decode($str, ENT_QUOTES), $nagiosCFGPath.$tab['id']."/hosts.cfg");
	fclose($handle);
	$DBRESULT->free();
	unset($str);
	unset($i);
?>