<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: formMibs.php 7139 2008-11-24 17:19:45Z jmathis $
 * 
 */ 	
 	if (!isset($oreon))
 		exit();
 		
	/*
	 * Debug Flag
	 */
	$debug = 0;
	
	/*
	 * Database retrieve information for Manufacturer
	 */
	
	function myDecodeMib($arg)	{
		$arg = html_entity_decode($arg, ENT_QUOTES);
		return($arg);
	}

	/*
	 * Set base value
	 */
	$mnftr = array(NULL => NULL);
	$DBRESULT =& $pearDB->query("SELECT `id`, `alias` FROM `traps_vendor` ORDER BY `alias`");
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
	while ($rmnftr =& $DBRESULT->fetchRow())
		$mnftr[$rmnftr["id"]] = $rmnftr["alias"];
	$DBRESULT->free();

	/*
	 * Init Formulary
	 */
	$form = new HTML_QuickForm('Form', 'post', "?p=".$p);
	$form->addElement('header', 'title', _("Load a MIB"));

	/*
	 * Manufacturer information
	 */
	$form->addElement('select', 'mnftr', _("Vendor Name"), $mnftr);
	$form->addElement('file', 'filename', _("File (.mib)"));

	/*
	 * Formulary Rules
	 */
	$form->applyFilter('__ALL__', 'myTrim');
	$form->addRule('mnftr', _("Compulsory Name"), 'required');
	$form->addRule('filename', _("Compulsory Name"), 'required');
	$form->setRequiredNote("<font style='color: red;'>*</font>". _(" Required fields"));

	/*
	 * Smarty template Init
	 */
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path, $tpl);

	/*
	 * Just watch a Command information
	 */
	$subA =& $form->addElement('submit', 'submit', _("Export"));
	$form->addElement('header', 'status',_("Status"));
	$valid = false;
	$msg = NULL;
	$stdout = NULL;
	if ($form->validate())	{
	
		$ret = $form->getSubmitValues();
	
		$fileObj =& $form->getElement('filename');
	
		if ($fileObj->isUploadedFile()) {
			/*
			 * Upload File
			 */
			$fileObj->moveUploadedFile("/tmp/");
			$values = $fileObj->getValue();
			$stdout = shell_exec("export LD_LIBRARY_PATH=".$oreon->optGen["perl_library_path"]." && export MIBS=ALL && ".$oreon->optGen["snmpttconvertmib_path_bin"]." --in=/tmp/".$values["name"]." --out=/tmp/".$values["name"].".conf 2>&1");
			if ($debug) 
				print ("export LD_LIBRARY_PATH=".$oreon->optGen["perl_library_path"]." && export MIBS=ALL && ".$oreon->optGen["snmpttconvertmib_path_bin"]." --in=/tmp/".$values["name"]." --out=/tmp/".$values["name"].".conf 2>&1");
			
			$msg .= "<br />".str_replace ("\n", "<br />", $stdout);
			$msg .= "<br />Moving traps in DataBase...";	
			
			if ($debug) 
				print("/usr/share/centreon/bin/centFillTrapDB -f /tmp/".$values["name"].".conf -m ".htmlentities($ret["mnftr"], ENT_QUOTES)." 2>&1");
			
			$stdout = shell_exec("/usr/share/centreon/bin/centFillTrapDB -f /tmp/".$values["name"].".conf -m ".htmlentities($ret["mnftr"], ENT_QUOTES)." 2>&1");
			shell_exec("rm /tmp/".$values["name"].".conf /tmp/".$values["name"]);
			$msg .= "<br />".str_replace ("\n", "<br />", $stdout);
			$msg .= "<br />Generate Traps configuration files from Nagios configuration form!";
			if ($msg)
				$tpl->assign('msg', $msg);
		}	
		$valid = true;
	}
	
	/*
	 * Apply a template definition
	 */
	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$renderer->setRequiredTemplate('{$label}&nbsp;<font color="red" size="1">*</font>');
	$renderer->setErrorTemplate('<font color="red">{$error}</font><br />{$html}');
	$form->accept($renderer);
	$tpl->assign('form', $renderer->toArray());
	$tpl->display("formMibs.ihtml");
?>