<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: AddHostDowntime.php 7139 2008-11-24 17:19:45Z jmathis $
 * 
 */
 
	if (!isset($oreon))
		exit();
	
	# Init
	$LCA_error = 0;
	if (!$is_admin){
		$lcaHostByName = getLcaHostByName($pearDB);
	}
	
	if (isset($_GET["host_name"])){
		$host_id = getMyHostID($_GET["host_name"]);
		if (!isset($lcaHostByName["LcaHost"] [$_GET["host_name"]]) && !$is_admin)
			$LCA_error = 1;
		$host_name = $_GET["host_name"];
	} else
		$host_name = NULL;
	
	if ($LCA_error)
		require_once("./alt_error.php");
	else {
		$data = array("host_id" => getMyHostID($host_name), "start" => date("Y/m/d G:i" , time() + 120), "end" => date("Y/m/d G:i", time() + 7320));
			
		#
		## Database retrieve information for differents elements list we need on the page
		#
		 
		$hosts = array(""=>"");
		$DBRESULT =& $pearDB->query("SELECT host_id, host_name, host_template_model_htm_id FROM `host` WHERE host_register = '1' ORDER BY host_name");
		if (PEAR::isError($DBRESULT))
			print "AddHostDowntime - RQ 1 : Mysql Error : ".$DBRESULT->getMessage();
		while ($host =& $DBRESULT->fetchRow()){
			if (!$host["host_name"])
				$host["host_name"] = getMyHostName($host["host_template_model_htm_id"]);
			if (isset($lcaHostByName["LcaHost"][$host["host_name"]]) || $is_admin)
				$hosts[$host["host_id"]]= $host["host_name"];
		}
		$DBRESULT->free();
		
		$debug = 0;
		$attrsTextI		= array("size"=>"3");
		$attrsText 		= array("size"=>"30");
		$attrsTextarea 	= array("rows"=>"7", "cols"=>"100");
		
		#
		## Form begin
		#
		
		$form = new HTML_QuickForm('Form', 'post', "?p=".$p);
		if ($o == "ah")
			$form->addElement('header', 'title', _("Add a Host downtime"));
		#
		## Indicator basic information
		#
				
		$redirect =& $form->addElement('hidden', 'o');
		$redirect->setValue($o);
		
	    $selHost =& $form->addElement('select', 'host_id', _("Host Name"), $hosts);
	    $form->addElement('checkbox', 'persistant', _("Fixed"));
		$form->addElement('text', 'start', _("Start Time"), $attrsText);
		$form->addElement('text', 'end', _("End Time"), $attrsText);
		$form->addElement('textarea', 'comment', _("Comments"), $attrsTextarea);
		
		$form->addRule('host_id', _("Required Field"), 'required');
		$form->addRule('end', _("Required Field"), 'required');
		$form->addRule('start', _("Required Field"), 'required');
		$form->addRule('comment', _("Required Field"), 'required');	
		
		$form->setDefaults($data);
		$subA =& $form->addElement('submit', 'submitA', _("Save"));
		$res =& $form->addElement('reset', 'reset', _("Reset"));
		
	  	if ((isset($_POST["submitA"]) && $_POST["submitA"]) && $form->validate())	{
			if (!isset($_POST["persistant"]))
				$_POST["persistant"] = 0;
			if (!isset($_POST["comment"]))
				$_POST["comment"] = 0;
			AddHostDowntime($_POST["host_id"], $_POST["comment"], $_POST["start"], $_POST["end"], $_POST["persistant"]);
			require_once("viewDowntime.php");
	    } else {	
			# Smarty template Init
			$tpl = new Smarty();
			$tpl = initSmartyTpl($path, $tpl, "template/");
				
			#Apply a template definition	
			$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
			$renderer->setRequiredTemplate('{$label}&nbsp;<font color="red" size="1">*</font>');
			$renderer->setErrorTemplate('<font color="red">{$error}</font><br />{$html}');
			$form->accept($renderer);	
			$tpl->assign('form', $renderer->toArray());	
			$tpl->assign('o', $o);		
			$tpl->display("AddHostDowntime.ihtml");
	    }
	}
?>