<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: viewDowntime.php 7243 2008-12-11 23:14:10Z jmathis $
 * 
 */
 	
	if (!isset($oreon))
		exit();

	/*
	 * ACL
	 */
	if (!$is_admin)
		$lcaHostByName = getLcaHostByName($pearDB);
	
	$ndo_base_prefix = getNDOPrefix();
	include_once("./DBNDOConnect.php");
	
	/*
	 * Smarty template Init
	 */
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path, $tpl, "template/");

	/*
	 * Pear library
	 */
	require_once "HTML/QuickForm.php";
	require_once 'HTML/QuickForm/advmultiselect.php';
	require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';

	$form = new HTML_QuickForm('select_form', 'GET', "?p=".$p);

	$tab_downtime_host = array();
	$tab_downtime_svc = array();

	/*
	 * Hosts Downtimes
	 */
	$rq2 =	" SELECT dtm.internal_downtime_id, unix_timestamp(dtm.entry_time), dtm.duration, dtm.author_name, dtm.comment_data, dtm.is_fixed, unix_timestamp(dtm.scheduled_start_time) AS scheduled_start_time, unix_timestamp(dtm.scheduled_end_time) AS scheduled_end_time, obj.name1 host_name, obj.name2 service_description " .
			" FROM ".$ndo_base_prefix."scheduleddowntime dtm, ".$ndo_base_prefix."objects obj " .
			" WHERE obj.name1 IS NOT NULL AND obj.name2 IS  NULL AND obj.object_id = dtm.object_id AND dtm.scheduled_end_time > '".date("Y-m-d G:i:s", time())."' ORDER BY dtm.actual_start_time";
	$DBRESULT_NDO =& $pearDBndo->query($rq2);
	if (PEAR::isError($DBRESULT_NDO))
		print "DB Error : ".$DBRESULT_NDO->getDebugInfo()."<br />";
	for ($i = 0; $data =& $DBRESULT_NDO->fetchRow(); $i++){
		$tab_downtime_host[$i] = $data;
		$tab_downtime_host[$i]["duration"] .= " "._("s");
		$tab_downtime_host[$i]["scheduled_start_time"] = date(_("Y/m/d - H:i:s"), $data["scheduled_start_time"]);
		$tab_downtime_host[$i]["scheduled_end_time"] = date(_("Y/m/d - H:i:s"), $data["scheduled_end_time"]);
	}
	unset($data);	

	
	$en = array("0" => _("No"), "1" => _("Yes"));
	foreach ($tab_downtime_host as $key => $value)
		$tab_downtime_host[$key]["is_fixed"] = $en[$tab_downtime_host[$key]["is_fixed"]];
	
	/*
	 * Service Downtimes
	 */
	$rq2 =	" SELECT dtm.internal_downtime_id, unix_timestamp(dtm.entry_time), dtm.duration, dtm.author_name, dtm.comment_data, dtm.is_fixed, unix_timestamp(dtm.scheduled_start_time) AS scheduled_start_time, unix_timestamp(dtm.scheduled_end_time) AS scheduled_end_time, obj.name1 host_name, obj.name2 service_description " .
			" FROM ".$ndo_base_prefix."scheduleddowntime dtm, ".$ndo_base_prefix."objects obj " .
			" WHERE obj.name1 IS NOT NULL AND obj.name2 IS NOT NULL AND obj.object_id = dtm.object_id AND dtm.scheduled_end_time > '".date("Y-m-d G:i:s", time())."' ORDER BY dtm.actual_start_time";
	$DBRESULT_NDO =& $pearDBndo->query($rq2);
	if (PEAR::isError($DBRESULT_NDO))
		print "DB Error : ".$DBRESULT_NDO->getDebugInfo()."<br />";
	for ($i = 0; $data =& $DBRESULT_NDO->fetchRow(); $i++) {
		$tab_downtime_svc[$i] = $data;
		$tab_downtime_svc[$i]["duration"] .= " "._("s");
		$tab_downtime_svc[$i]["scheduled_start_time"] = date(_("Y/m/d - H:i:s"), $data["scheduled_start_time"]);
		$tab_downtime_svc[$i]["scheduled_end_time"] = date(_("Y/m/d - H:i:s"), $data["scheduled_end_time"]);		
	}
	unset($data);	

	$en = array("0" => _("No"), "1" => _("Yes"));
	foreach ($tab_downtime_svc as $key => $value)
		$tab_downtime_svc[$key]["is_fixed"] = $en[$tab_downtime_svc[$key]["is_fixed"]];

	if (!$is_admin){
		$tab_downtime_host2 = array();
		for ($n=0,$i=0; $i < count($tab_downtime_host); $i++) {
			if (isset($lcaHostByName["LcaHost"][$tab_downtime_host[$i]["host_name"]]))
				$tab_downtime_host2[$n++] = $tab_downtime_host[$i];
		}
		$tab_downtime_svc2 = array();
		for ($n=0,$i=0; $i < count($tab_downtime_svc); $i++) {
			if (isset($lcaHostByName["LcaHost"][$tab_downtime_svc[$i]["host_name"]]))
				$tab_downtime_svc2[$n++] = $tab_downtime_svc[$i];
		}

		$tab_downtime_host = $tab_downtime_host2;
		$tab_downtime_svc = $tab_downtime_svc2;
	}

	# Element we need when we reload the page
	$form->addElement('hidden', 'p');
	$tab = array ("p" => $p);
	$form->setDefaults($tab);

	$tpl->assign('msgh', array ("addL"=>"?p=".$p."&o=ah", "addT"=>_("Add"), "delConfirm"=>_("Do you confirm the deletion ?")));
	$tpl->assign('msgs', array ("addL"=>"?p=".$p."&o=as", "addT"=>_("Add"), "delConfirm"=>_("Do you confirm the deletion ?")));
	$tpl->assign("p", $p);
	
	$tpl->assign("tab_downtime_host", $tab_downtime_host);
	$tpl->assign("tab_downtime_svc", $tab_downtime_svc);
	$tpl->assign("nb_downtime_host", count($tab_downtime_host));
	$tpl->assign("nb_downtime_svc", count($tab_downtime_svc));
	
	$tpl->assign("dtm_host_name", _("Host Name"));
	$tpl->assign("dtm_service_descr", _("Services"));
	$tpl->assign("dtm_start_time", _("start Time"));
	$tpl->assign("dtm_end_time", _("End Time"));
	$tpl->assign("dtm_author", _("Author"));
	$tpl->assign("dtm_comment", _("Comments"));
	$tpl->assign("dtm_fixed", _("Fixed"));
	$tpl->assign("dtm_duration", _("Duration"));
	$tpl->assign("dtm_host_downtime", _("Hosts Downtimes"));
	$tpl->assign("dtm_service_downtime", _("Services Downtimes"));
	
	$tpl->assign("no_svc_dtm", _("No downtime scheduled for services"));
	$tpl->assign("no_host_dtm", _("No downtime scheduled for hosts"));

	$tpl->assign("delete", _("Delete"));
	
	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$form->accept($renderer);
	$tpl->assign('form', $renderer->toArray());
	$tpl->display("downtime.ihtml");
?>