<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: functions.php 7143 2008-11-24 23:12:05Z jmathis $
 * 
 */
 
	if (!isset($oreon))
		exit();	

	$tab["1"] = "ENABLE";
	$tab["0"] = "DISABLE";

	function write_command($cmd, $poller){
		global $oreon, $key, $pearDB;
		$str = NULL;
		$cmd = htmlentities($cmd);
		$informations = split(";", $key);
		if ($poller && isPollerLocalhost($pearDB, $poller))
			$str = "echo '[" . time() . "]" . $cmd . "\n' >> " . $oreon->Nagioscfg["command_file"];
		else if (isHostLocalhost($pearDB, $informations[0]))
			$str = "echo '[" . time() . "]" . $cmd . "\n' >> " . $oreon->Nagioscfg["command_file"];
		else
			$str = "echo 'EXTERNALCMD:$poller:[" . time() . "]" . $cmd . "\n' >> " . "/var/lib/centreon/centcore.cmd";
		return passthru($str);
	}

	function send_cmd($arg){
		if (isset($arg))
			$flg = write_command($arg);
		$flg ? $ret = _("Your command has been sent") : $ret = "Problem Execution";
		return $ret;
	}
	
	// Re-Schedule for all service of an host
	
	function schedule_host_svc_checks($arg, $forced){
		global $pearDB;
		$tab_forced = array("0" => "", "1" => "_FORCED");
		$flg = write_command(" SCHEDULE".$tab_forced[$forced]."_HOST_SVC_CHECKS;" . $arg . ";" . time(), GetMyHostPoller($pearDB, $arg));
		return $flg;
	}
	
	// SCHEDULE_SVC_CHECK
	
	function schedule_svc_checks($arg, $forced){
		global $pearDB;
		$tab_forced = array("0" => "", "1" => "_FORCED");
		$tab_data = split(";", $arg);
		if ($tab_data[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$tab_data[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $tab_data[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" SCHEDULE".$tab_forced[$forced]."_SVC_CHECK;". $tab_data[0] . ";" . $tab_data[1] . ";" . time(), GetMyHostPoller($pearDB, $tab_data[0]));
		return _("Your command has been sent");
	}
	
	// host check
	
	function host_check($arg, $type){
		global $tab, $pearDB;
		$flg = write_command(" ". $tab[$type]."_HOST_CHECK;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	//  host notification
	
	function host_notification($arg, $type){
		global $tab, $pearDB;
		$flg = write_command(" ".$tab[$type]."_HOST_NOTIFICATIONS;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	// ENABLE_HOST_SVC_NOTIFICATIONS
	
	function host_svc_notifications($arg, $type){
		global $tab, $pearDB;
		$flg = write_command(" " . $tab[$type] . "_HOST_SVC_NOTIFICATIONS;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	// ENABLE_HOST_SVC_CHECKS
	
	function host_svc_checks($arg, $type){
		global $tab, $pearDB;
		$flg = write_command(" " . $tab[$type] . "_HOST_SVC_CHECKS;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	// ENABLE_HOST_SVC_CHECKS
	
	function svc_check($arg, $type){
		global $tab, $pearDB;
		$tab_data = split(";", $arg);
		if ($tab_data[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$tab_data[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $tab_data[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" " . $tab[$type] . "_SVC_CHECK;". $tab_data["0"] .";".$tab_data["1"], GetMyHostPoller($pearDB, $tab_data["0"]));
		return _("Your command has been sent");
	}
	
	// PASSIVE_SVC_CHECKS
	
	function passive_svc_check($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_PASSIVE_SVC_CHECKS;". $tab_data[0] . ";". $tab_data[1], GetMyHostPoller($pearDB, $tab_data["0"]));
		return _("Your command has been sent");
	}
	
	// SVC_NOTIFICATIONS
	
	function svc_notifications($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		if ($tab_data[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$tab_data[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $tab_data[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" " . $tab[$type] . "_SVC_NOTIFICATIONS;". $tab_data[0] . ";". $tab_data[1], GetMyHostPoller($pearDB, $tab_data["0"]));
		return _("Your command has been sent");
	}
	
	// _SVC_EVENT_HANDLER
	
	function svc_event_handler($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_SVC_EVENT_HANDLER;". $tab_data[0] .";".$tab_data[1], GetMyHostPoller($pearDB, $tab_data["0"]));
		return _("Your command has been sent");
	}
	
	// _HOST_EVENT_HANDLER
	
	function host_event_handler($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_HOST_EVENT_HANDLER;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	//_SVC_FLAP_DETECTION
	
	function svc_flapping_enable($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_SVC_FLAP_DETECTION;". $tab_data[0] .";".$tab_data[1], GetMyHostPoller($pearDB, $tab_data[0]));
		return _("Your command has been sent");
	}
	
	//_HOST_FLAP_DETECTION
	
	function host_flapping_enable($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_HOST_FLAP_DETECTION;". $arg, GetMyHostPoller($pearDB, $arg));
		return _("Your command has been sent");
	}
	
	function notifi_host_hostgroup($arg, $type){
		global $pearDB,$tab;
		$tab_data = split(";", $arg);
		$flg = write_command(" " . $tab[$type] . "_HOST_NOTIFICATIONS;". $tab_data[0], GetMyHostPoller($pearDB, $tab_data[0]));
		return _("Your command has been sent");
	}
	
	function acknowledgeHost(){
		global $pearDB,$tab, $_GET, $key;
		$key = $_GET["host_name"];
		$flg = write_command(" ACKNOWLEDGE_HOST_PROBLEM;".$_GET["host_name"].";1;".$_GET["notify"].";".$_GET["persistent"].";".$_GET["author"].";".$_GET["comment"], GetMyHostPoller($pearDB, $_GET["host_name"]));
		return _("Your command has been sent");
	}
	
	function acknowledgeHostDisable(){
		global $pearDB,$tab, $_GET;
		$flg = write_command(" REMOVE_HOST_ACKNOWLEDGEMENT;".$_GET["host_name"], GetMyHostPoller($pearDB, $_GET["host_name"]));
		return _("Your command has been sent");
	}
	
	function acknowledgeServiceDisable(){
		global $pearDB,$tab;
		$flg = write_command(" REMOVE_SVC_ACKNOWLEDGEMENT;".$_GET["host_name"].";".$_GET["service_description"], GetMyHostPoller($pearDB, $_GET["host_name"]));
		return _("Your command has been sent");
	}

	function acknowledgeService(){
		global $pearDB,$tab;
		$_GET["comment"] = $_GET["comment"];
		$_GET["comment"] = str_replace('\'', ' ', $_GET["comment"]);
		$flg = write_command(" ACKNOWLEDGE_SVC_PROBLEM;".$_GET["host_name"].";".$_GET["service_description"].";1;".$_GET["notify"].";".$_GET["persistent"].";".$_GET["author"].";".$_GET["comment"], GetMyHostPoller($pearDB, $_GET["host_name"]));
		return _("Your command has been sent");
	}

	function submitPassiveCheck(){
		global $pearDB, $key;
		$key = $_GET["host_name"];
		$flg = write_command(" PROCESS_SERVICE_CHECK_RESULT;".$_GET["host_name"].";".$_GET["service_description"].";".$_GET["return_code"].";".$_GET["output"]."|".$_GET["dataPerform"], GetMyHostPoller($pearDB, $_GET["host_name"]));
		return _("Your command has been sent");
	}
	
	
	function notifi_svc_host_hostgroup($arg, $type){
		global $tab, $pearDB;
	/*	$res =& $pearDB->query("SELECT host_host_id FROM hostgroup_relation WHERE hostgroup_hg_id = '".$arg."'");
		while ($r =& $res->fetchRow()){
			$resH =& $pearDB->query("SELECT host_name FROM host WHERE host_id = '".$r["host_host_id"]."'");
			$rH =& $resH->fetchRow();
			$flg = write_command(" " . $tab[$type] . "_HOST_NOTIFICATIONS;". $rH["host_name"]);
		}
	*/
		return _("Your command has been sent");
	}
	
	function checks_svc_host_hostgroup($arg, $type){
		global $tab, $pearDB;
		/*$res =& $pearDB->query("SELECT host_host_id FROM hostgroup_relation WHERE hostgroup_hg_id = '".$arg."'");
		$r =& $res->fetchRow();
		$flg = write_command(" " . $tab[$type] . "_HOST_SVC_CHECKS;". $rH["host_name"]);
		*/
		return _("Your command has been sent");
	}
	
	#############################################################################
	# Monitoring Quick Actions
	#############################################################################
	
	/* Acknowledge */
	
	function autoAcknowledgeServiceStart($key){
		global $pearDB,$tab,$oreon;
		$comment = "Service Auto Acknowledge by ".$oreon->user->alias."\n";
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" ACKNOWLEDGE_SVC_PROBLEM;".$ressource[0].";".$ressource[1].";1;1;1;".$oreon->user->alias.";".$comment, GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoAcknowledgeServiceStop($key){
		global $pearDB,$tab,$oreon;
		$comment = "Service Auto Acknowledge by ".$oreon->user->alias."\n";
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" REMOVE_SVC_ACKNOWLEDGEMENT;".$ressource[0].";".$ressource[1], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoAcknowledgeHostStart($key){
		global $pearDB,$tab,$oreon;
		$comment = "Host Auto Acknowledge by ".$oreon->user->alias."\n";
		$ressource = split(";", $key);
		$flg = write_command(" ACKNOWLEDGE_HOST_PROBLEM;".$ressource[0].";1;1;1;".$oreon->user->alias.";".$comment, GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoAcknowledgeHostStop($key){
		global $pearDB,$tab,$oreon;
		$comment = "Host Auto Acknowledge by ".$oreon->user->alias."\n";
		$ressource = split(";", $key);
		$flg = write_command(" REMOVE_HOST_ACKNOWLEDGEMENT;".$ressource[0], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	/* Notification */
	
	function autoNotificationServiceStart($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" ENABLE_SVC_NOTIFICATIONS;".$ressource[0].";".$ressource[1], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoNotificationServiceStop($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" DISABLE_SVC_NOTIFICATIONS;".$ressource[0].";".$ressource[1], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoNotificationHostStart($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		$flg = write_command(" ENABLE_HOST_NOTIFICATIONS;".$ressource[0], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoNotificationHostStop($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		$flg = write_command(" DISABLE_HOST_NOTIFICATIONS;".$ressource[0], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	/* Check */
	
	function autoCheckServiceStart($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" ENABLE_SVC_CHECK;".$ressource[0].";".$ressource[1], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoCheckServiceStop($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		if ($ressource[0] == "Meta_Module") {
		   $DBRESULT =& $pearDB->query("SELECT meta_id FROM meta_service WHERE meta_name = '".$ressource[1]."'");
		   $meta =& $DBRESULT->fetchRow();
		   $ressource[1] = "meta_".$meta["meta_id"];
		   $DBRESULT->free();
		}
		$flg = write_command(" DISABLE_SVC_CHECK;".$ressource[0].";".$ressource[1], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoCheckHostStart($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		$flg = write_command(" ENABLE_HOST_CHECK;".$ressource[0], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
	function autoCheckHostStop($key){
		global $pearDB,$tab;
		$ressource = split(";", $key);
		$flg = write_command(" DISABLE_HOST_CHECK;".$ressource[0], GetMyHostPoller($pearDB, $ressource[0]));
		return _("Your command has been sent");
	}
	
?>
