<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: get_status_data.php 7139 2008-11-24 17:19:45Z jmathis $
 * 
 */
 
	require ("../../oreon.conf.php");
	require ("../../DBconnect.php");
	
	function get_status_data($status_file = NULL){
		/*
		 * Error
		 * 1 : No status_file in parameter
		 * 2 : Status_file is not readable
		 * 
		 */  
		$status_data = array();
		global $pearDB;
		
		$DBRESULT =& $pearDB->query("SELECT nagios_version FROM general_opt");
		if (PEAR::isError($DBRESULT))
			print "Mysql Error : ".$DBRESULT->getMessage();
		$nagios_version =& $DBRESULT->fetchRow();
		$version = $nagios_version["nagios_version"];
		
		$tab_status_svc = array("0" => "OK", "1" => "WARNING", "2" => "CRITICAL", "3" => "UNKNOWN", "4" => "PENDING");
		$tab_status_host = array("0" => "UP", "1" => "DOWN", "2" => "UNREACHABLE");
		
		if (!$status_file)
			return $status_data;
		
		if (is_readable($status_file))
			$log_file = fopen($status_file, "r");
		else
			return $status_data;
		
		$tab = array();
		
		// Read 
		$cpt = 0;
		if ($log_file)
			while ($str = fgets($log_file))
				if ($version == 1){		
					if (!preg_match("/^\#.*/", $str)){ // Do not get comments
						if (preg_match("/^[\[\]0-9\ ]* SERVICE[.]*/", $str)){
							$log = split(";", $str);
							$status_data[$cpt] = array("0"=>$log["1"], "1"=>$log["3"], "2"=>$log["2"]);
							$cpt++;
						}	
						if (preg_match("/^[\[\]0-9]* HOST[.]*/", $str)){
							$log = split(";", $str);
							$status_data[$cpt] = array("0"=>$log["1"], "1"=>$log["2"]);
							$cpt++;
						}
					}
				} else {
					if (!preg_match("/^\#.*/", $str)){ // Do not get comments
						if (preg_match("/^service/", $str)){   
						  	$log = array();
						 	 while ($str2 = fgets($log_file))
       		          			if (!preg_match("/^[\ \t]*\}$/", $str2)){
					   				if (preg_match("/([A-Za-z0-9\_\-]*)\=(.*)[\ \t]*/", $str2, $tab)){
										$log[$tab[1]] = $tab[2];
				          			}
					    		} else
					      			break;
				      			$status_data[$cpt] = array("0"=>$log["host_name"], "1"=>$tab_status_svc[$log['current_state']], "2"=>$log["service_description"]);
								$cpt++;
				  				unset($log);
					  	} else if (preg_match("/^host/", $str)){ // get host stat
							$log = array();
						  	while ($str2 = fgets($log_file))
       		          			if (!preg_match("/^[\ \t]*\}$/", $str2)){
						      		if (preg_match("/([A-Za-z0-9\_\-]*)\=(.*)[\ \t]*/", $str2, $tab)){
										$log[$tab[1]] = $tab[2];
						      		} 
						    	} else
						      		break;
						      	$status_data[$cpt] = array("0"=>$log['host_name'], "1"=>$tab_status_host[$log['current_state']]);
								$cpt++;
								unset($log);
						}
					}
				}			
		return ($status_data);
	}
?>