<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * SVN : $URL
 * SVN : $Id: getStats.php 7139 2008-11-24 17:19:45Z jmathis $
 * 
 */	
	
	/*
	 * Filter get parameters
	 *
	 * <code>
	 * $_GET["o"] = filter_get($_GET["o"]);
	 * </code>
	 *
	 * @param{TAB}string{TAB}$str{TAB}a get string
	 * @return{TAB}string{TAB}return get string
	 */
		
	function filter_get($str){
		if (preg_match("/([a-zA-Z0-9\_\-\%\ ]*)/", $str, $matches))
			return $matches[1];
		return NULL;	
	}
	
	foreach ($_GET as $key => $get){
		$tab = split(';', $_GET[$key]);
		$_GET[$key] = $tab[0];
		if (function_exists("filter_var")){
			$_GET[$key] = filter_var($_GET[$key], FILTER_SANITIZE_SPECIAL_CHARS);
		} else {
			$_GET[$key] = filter_get($_GET[$key]);
		}
	}

	/*
	 * escape special char for commands
	 *
	 * <code>
	 * $string = escape_command($string);
	 * </code>
	 *
	 * @param{TAB}string{TAB}$command{TAB}command line
	 * @return{TAB}string{TAB}command line
	 */
		
	function escape_command($command) {
		return ereg_replace("(\\\$|`)", "", $command);
	}
	
	require_once("/etc/centreon/centreon.conf.php");
	require_once("$centreon_path/www/DBconnect.php");
	require_once("$centreon_path/www/DBOdsConnect.php");

	/*
	 * Get RRDTool binary Path 
	 */
	 
	$DBRESULT =& $pearDB->query("SELECT `rrdtool_path_bin` FROM `general_opt`");
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
	$options =& $DBRESULT->fetchRow();
	$rrdtoolPath = $options["rrdtool_path_bin"];
	unset($options);
	$DBRESULT->free();

	$title	 = array(	
				"active_host_check" => _("Host checks"), 
				"active_host_last" => _("Active hosts"),
				"host_latency" => _("Host check latency"),
				"active_service_check" => _("Service checks"), 
				"active_service_last" => _("Active services"), 
				"service_latency" => _("Service check latency"), 
				"cmd_buffer" => _("Commands in buffer"), 
				"host_states" => _("Host status"), 
				"service_states" => _("Services status"));

	$options = array(	
				"active_host_check" => "nagios_active_host_execution.rrd", 
				"active_host_last" => "nagios_active_host_last.rrd",
				"host_latency" => "nagios_active_host_latency.rrd",
				"active_service_check" => "nagios_active_service_execution.rrd", 
				"active_service_last" => "nagios_active_service_last.rrd", 
				"service_latency" => "nagios_active_service_latency.rrd", 
				"cmd_buffer" => "nagios_cmd_buffer.rrd", 
				"host_states" => "nagios_hosts_states.rrd", 
				"service_states" => "nagios_services_states.rrd");

	$differentStats = array(	
				"nagios_active_host_execution.rrd" => array("Used", "High", "Total"), 
				"nagios_active_host_last.rrd" => array("T1", "T5", "T15", "T60"), 
				"nagios_active_host_latency.rrd" => array("Used", "High", "Total"), 
				"nagios_active_service_execution.rrd" => array("Used", "High", "Total"), 
				"nagios_active_service_last.rrd" => array("T1", "T5", "T15", "T60"), 
				"nagios_active_service_latency.rrd" => array("Used", "High", "Total"), 
				"nagios_cmd_buffer.rrd" => array("Used", "High", "Total"), 
				"nagios_hosts_states.rrd" => array("Up", "Down", "Unreach"), 
				"nagios_services_states.rrd" => array("Ok", "Warn", "Crit", "Unk"));


	/*
	 * Verify if start and end date
	 */	

	if (!isset($_GET["start"])) {		
		$start = time() - (60*60*24);		
	} else {				
		switch ($_GET["start"]) {
			case "today" : 
				$start = time() - (60*60*24); 
				break;
			case "yesterday" : 
				$start = time() - (60*60*48); 
				break;
			case "last4days" : 
				$start = time() - (60*60*96);
				break;
			case "lastweek" : 
				$start = time() - (60*60*168); 
				break;
			case "lastmonth" : 
				$start = time() - (60*60*24*30); 
				break;
			case "last6month" : 
				$start = time() - (60*60*24*30*6); 
				break;
			case "lastyear" : 
				$start = time() - (60*60*24*30*12); 
				break;
		}
	}
	
	/*
	 * Get end values
	 */
	if (!isset($_GET["end"]))
		$end = time();
	else
		$end = $_GET["end"];

	/*
	 * Begin Command Line
	 */
	$command_line = " graph - --start=".$start." --end=".$end;

	/*
	 * get all template infos
	 */
	 
	$command_line .= " --interlaced --imgformat PNG --width=400 --height=100 --title='".$title[$_GET["key"]]."' --vertical-label='".$_GET["key"]."' --slope-mode  ";
	$command_line .= "--rigid --alt-autoscale-max ";
			
	/*
	 * Init DS template For each curv
	 */
	
	$colors = array("1"=>"#19EE11", "2"=>"#82CFD8", "3"=>"#F8C706", "4"=>"#F8C706");
	
	$metrics = $differentStats[$options[$_GET["key"]]];
	$cpt = 1;
	$DBRESULT =& $pearDBO->query("SELECT RRDdatabase_nagios_stats_path FROM config");
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br />";
	while ($nagios_stats =& $DBRESULT->fetchRow())
		$nagios_stats_path = $nagios_stats['RRDdatabase_nagios_stats_path'];

	foreach ($metrics as $key => $value){
		$command_line .= " DEF:v".$cpt."=".$nagios_stats_path."perfmon-".$_GET["ns_id"]."/".$options[$_GET["key"]].":".$value.":AVERAGE ";
		$cpt++;
	}
	$command_line .= " COMMENT:\" \\l\" ";
	
	/*
	 * Create Legende
	 */
	$cpt = 1;

	foreach ($metrics as $key => $tm){
		$command_line .= " LINE1:v".($cpt);
		$command_line .= $colors[$cpt].":\"";
		$command_line .= $tm."\"";
		$cpt++;
	}

	$command_line = "$rrdtoolPath ".$command_line." 2>&1";
	$command_line = escape_command("$command_line");

	//print $command_line;
	$fp = popen($command_line  , 'r');
	if (isset($fp) && $fp ) {
		$str ='';
		while (!feof ($fp)) {
	  		$buffer = fgets($fp, 4096);
	 		$str = $str . $buffer ;
		}
		print $str;
	}
?>